package cn.efunbox.audio.utils;

import it.sauronsoftware.jave.MultimediaInfo;
import it.sauronsoftware.jave.Encoder;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Objects;

public class VideoUtil {


    public static void videoTimeLength(File file) {
        try {
            File tempFile = null;
            InputStream inputStream = new FileInputStream(file);
            Workbook wb = getWorkbook(inputStream,"百度教材接口数据0229.xlsx");
            //解析
            Sheet sheet = wb.getSheetAt(0);
            int rows = sheet.getPhysicalNumberOfRows();
            for (int i = 1; i < rows; i++) {
                Row row = sheet.getRow(i);
                if (!Objects.isNull(row)) {
                    String title = getCell(row.getCell(8));
                    String playUrl = getCell(row.getCell(11));
                    String trackLength = "";
                    tempFile = getFileByUrl(playUrl);
                    MultimediaInfo mInfo = new Encoder().getInfo(tempFile);
                    long length = mInfo.getDuration();
                    int h = (int)(length/3600000);
                    long hr = length%3600000;
                    long m = ((hr)/60000);
                    long mr = length%60000;
                    int s = (int)mr/1000;
                    if(h<10){
                        trackLength+="0"+h;
                    }else{
                        trackLength +=h;
                    }
                    trackLength += ":";
                    if(m<10){
                        trackLength+="0"+m;
                    }else {
                        trackLength += m;
                    }
                    trackLength += ":";
                    if(s<10){
                        trackLength+="0"+s;
                    }else {
                        trackLength += s;
                    }
                    System.out.println(title+"================"+trackLength);
                    row.getCell(12).setCellValue(trackLength);
                }

            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 获取工作簿对象
     * @param inStr
     * @param fileName
     * @return
     * @throws Exception
     */
    private static Workbook getWorkbook(InputStream inStr, String fileName) throws Exception {
        Workbook wb = null;
        String fileType = fileName.substring(fileName.lastIndexOf(".") + 1 );
        if ("xls".equals(fileType)) {
            wb = new HSSFWorkbook(inStr);  //2003-
        } else if ("xlsx".equals(fileType)) {
            wb = new XSSFWorkbook(inStr);  //2007+
        } else {
            throw new Exception("解析的文件格式有误！");
        }
        return wb;
    }

    private static String getCell(Cell cell) {
        if (Objects.nonNull(cell)) {
            CellType cellType = cell.getCellTypeEnum();
            if (cellType == CellType.STRING) {//字符串类型
                //System.out.println(cell.getStringCellValue());
                return cell.getStringCellValue().trim();
            }
            if (cellType == CellType.NUMERIC) {//数字类型
                int numericCellValue = (int) cell.getNumericCellValue();
                //System.out.println(numericCellValue);
                return numericCellValue + "";
            }
        }
        return null;
    }

    /**
     * 获取网络文件，暂存为临时文件
     * @param url
     * @return
     * @throws IOException
     */
    public static File getFileByUrl(String url) throws IOException {
        File tmpFile = File.createTempFile("temp", ".tmp");//创建临时文件
        Image2Binary.toBDFile(url, tmpFile.getCanonicalPath());
        return tmpFile;
    }

    public static void main(String[] args) {
        File file = new File("C:\\Users\\Administrator\\Desktop\\百度教材接口数据0229.xlsx");
        videoTimeLength(file);
    }
}
